Package org.flowable.task.api

# Interface TaskInfoQuery<T extends TaskInfoQuery<?,?>,V extends TaskInfo>

All Superinterfaces:
  `Query<T,V>`

All Known Subinterfaces:
  `HistoricTaskInstanceQuery`, `TaskQuery`

public interface TaskInfoQuery<T extends TaskInfoQuery<?,?>,V extends TaskInfo> extends Query<T,V>
Interface containing shared methods between the `TaskQuery` and the `HistoricTaskInstanceQuery`.

Author:
  Joram Barrez

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.flowable.common.engine.api.query.Query

  `Query.NullHandlingOnOrder`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `T`
  `caseDefinitionId(String caseDefinitionId)`
  Only select tasks for the given case definition.
  `T`
  `caseDefinitionKey(String caseDefinitionKey)`
  Only select tasks which are part of a case instance which has the given case definition key.
  `T`
  `caseDefinitionKeyIn(Collection<String> caseDefinitionKeys)`
  Only select tasks that have a case definition for which the key is present in the given list
  `T`
  `caseDefinitionKeyLike(String caseDefinitionKeyLike)`
  Only select tasks which are part of a case instance which has a case definition key like the given value.
  `T`
  `caseDefinitionKeyLikeIgnoreCase(String caseDefinitionKeyLikeIgnoreCase)`
  Only select tasks which are part of a case instance which has a case definition key like the given value.
  `T`
  `caseInstanceId(String caseInstanceId)`
  Only select tasks for the given case instance.
  `T`
  `caseInstanceIdWithChildren(String caseInstanceId)`
  Select all tasks for the given case instance id and its children.
  `T`
  `caseVariableExists(String name)`
  Only select tasks which have a global variable with the given name.
  `T`
  `caseVariableNotExists(String name)`
  Only select tasks which does not have a global variable with the given name.
  `T`
  `caseVariableValueEquals(Object variableValue)`
  Only select tasks which are part of a case that has at least one variable with the given value.
  `T`
  `caseVariableValueEquals(String variableName, Object variableValue)`
  Only select tasks which are part of a case that has a variable with the given name set to the given value.
  `T`
  `caseVariableValueEqualsIgnoreCase(String name, String value)`
  Only select tasks which are part of a case that has a local string variable which is not the given value, case insensitive.
  `T`
  `caseVariableValueGreaterThan(String name, Object value)`
  Only select tasks which have a global variable value greater than the passed value when they ended.
  `T`
  `caseVariableValueGreaterThanOrEqual(String name, Object value)`
  Only select tasks which have a global variable value greater than or equal to the passed value when they ended.
  `T`
  `caseVariableValueLessThan(String name, Object value)`
  Only select tasks which have a global variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
  `T`
  `caseVariableValueLessThanOrEqual(String name, Object value)`
  Only select tasks which have a global variable value less than or equal to the passed value when they ended.
  `T`
  `caseVariableValueLike(String name, String value)`
  Only select tasks which have a global variable value like the given value when they ended.
  `T`
  `caseVariableValueLikeIgnoreCase(String name, String value)`
  Only select tasks which have a global variable value like the given value (case insensitive) when they ended.
  `T`
  `caseVariableValueNotEquals(String variableName, Object variableValue)`
  Only select tasks which have a variable with the given name, but with a different value than the passed value.
  `T`
  `caseVariableValueNotEqualsIgnoreCase(String name, String value)`
  Only select tasks which are part of a case that has a string variable with the given value, case insensitive.
  `T`
  `cmmnDeploymentId(String cmmnDeploymentId)`
  Only select tasks which are related to a case instance for to the given deployment id.
  `T`
  `cmmnDeploymentIdIn(Collection<String> cmmnDeploymentIds)`
  Only select tasks which are related to a case instances for the given deployment id.
  `T`
  `deploymentId(String deploymentId)`
  Only select tasks which are part of a process instance which has the given deployment id.
  `T`
  `deploymentIdIn(Collection<String> deploymentIds)`
  Only select tasks which are part of a process instance which has the given deployment id.
  `T`
  `endOr()`
  `T`
  `executionId(String executionId)`
  Only select tasks for the given execution.
  `T`
  `ignoreAssigneeValue()`
  Allows to select a task using `taskCandidateGroup(String)` `taskCandidateGroupIn(Collection)` or `taskCandidateUser(String)` but ignore the assignee value instead of querying for an empty assignee.
  `T`
  `includeCaseVariables()`
  Include global case variables in the task query result
  `T`
  `includeIdentityLinks()`
  Include identity links in the task query result
  `T`
  `includeProcessVariables()`
  Include global process variables in the task query result
  `T`
  `includeTaskLocalVariables()`
  Include local task variables in the task query result
  `T`
  `locale(String locale)`
  Localize task name and description to specified locale.
  `T`
  `or()`
  All query clauses called will be added to a single or-statement.
  `T`
  `orderByCategory()`
  Order by category (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByDueDateNullsFirst()`
  Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByDueDateNullsLast()`
  Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByExecutionId()`
  Order by execution id (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByProcessDefinitionId()`
  Order by process definition id (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByProcessInstanceId()`
  Order by process instance id (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskAssignee()`
  Order by assignee (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskCreateTime()`
  Order by the time on which the tasks were created (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskDefinitionKey()`
  Order by task definition key (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskDescription()`
  Order by description (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskDueDate()`
  Order by task due date (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskId()`
  Order by task id (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskName()`
  Order by task name (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskOwner()`
  Order by task owner (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTaskPriority()`
  Order by priority (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `orderByTenantId()`
  Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).
  `T`
  `planItemInstanceId(String planItemInstanceId)`
  Only select tasks for the given plan item instance.
  `T`
  `processCategoryIn(Collection<String> processCategoryInList)`
  Only select tasks which are part of a process instance whose definition belongs to the category which is present in the given list.
  `T`
  `processCategoryNotIn(Collection<String> processCategoryNotInList)`
  Only select tasks which are part of a process instance whose definition does not belong to the category which is present in the given list.
  `T`
  `processDefinitionId(String processDefinitionId)`
  Only select tasks which are part of a process instance which has the given process definition id.
  `T`
  `processDefinitionKey(String processDefinitionKey)`
  Only select tasks which are part of a process instance which has the given process definition key.
  `T`
  `processDefinitionKeyIn(Collection<String> processDefinitionKeys)`
  Only select tasks that have a process definition for which the key is present in the given list
  `T`
  `processDefinitionKeyLike(String processDefinitionKeyLike)`
  Only select tasks which are part of a process instance which has a process definition key like the given value.
  `T`
  `processDefinitionKeyLikeIgnoreCase(String processDefinitionKeyLikeIgnoreCase)`
  Only select tasks which are part of a process instance which has a process definition key like the given value.
  `T`
  `processDefinitionName(String processDefinitionName)`
  Only select tasks which are part of a process instance which has the given process definition name.
  `T`
  `processDefinitionNameLike(String processDefinitionNameLike)`
  Only select tasks which are part of a process instance which has a process definition name like the given value.
  `T`
  `processInstanceBusinessKey(String processInstanceBusinessKey)`
  Only select tasks for the given business key
  `T`
  `processInstanceBusinessKeyLike(String processInstanceBusinessKeyLike)`
  Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%test%").
  `T`
  `processInstanceBusinessKeyLikeIgnoreCase(String processInstanceBusinessKeyLikeIgnoreCase)`
  Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%test%").
  `T`
  `processInstanceId(String processInstanceId)`
  Only select tasks for the given process instance id.
  `T`
  `processInstanceIdIn(Collection<String> processInstanceIds)`
  Only select tasks for the given process ids.
  `T`
  `processInstanceIdWithChildren(String processInstanceId)`
  Select all tasks for the given process instance id and its children.
  `T`
  `processVariableExists(String name)`
  Only select tasks which have a global variable with the given name.
  `T`
  `processVariableNotExists(String name)`
  Only select tasks which does not have a global variable with the given name.
  `T`
  `processVariableValueEquals(Object variableValue)`
  Only select tasks which are part of a process that has at least one variable with the given value.
  `T`
  `processVariableValueEquals(String variableName, Object variableValue)`
  Only select tasks which are part of a process that has a variable with the given name set to the given value.
  `T`
  `processVariableValueEqualsIgnoreCase(String name, String value)`
  Only select tasks which are part of a process that has a local string variable which is not the given value, case insensitive.
  `T`
  `processVariableValueGreaterThan(String name, Object value)`
  Only select tasks which have a global variable value greater than the passed value when they ended.
  `T`
  `processVariableValueGreaterThanOrEqual(String name, Object value)`
  Only select tasks which have a global variable value greater than or equal to the passed value when they ended.
  `T`
  `processVariableValueLessThan(String name, Object value)`
  Only select tasks which have a global variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
  `T`
  `processVariableValueLessThanOrEqual(String name, Object value)`
  Only select tasks which have a global variable value less than or equal to the passed value when they ended.
  `T`
  `processVariableValueLike(String name, String value)`
  Only select tasks which have a global variable value like the given value when they ended.
  `T`
  `processVariableValueLikeIgnoreCase(String name, String value)`
  Only select tasks which have a global variable value like the given value (case insensitive) when they ended.
  `T`
  `processVariableValueNotEquals(String variableName, Object variableValue)`
  Only select tasks which have a variable with the given name, but with a different value than the passed value.
  `T`
  `processVariableValueNotEqualsIgnoreCase(String name, String value)`
  Only select tasks which are part of a process that has a string variable with the given value, case insensitive.
  `T`
  `propagatedStageInstanceId(String propagatedStageInstanceId)`
  Only select tasks for the given stage, defined through its stage instance id.
  `T`
  `scopeDefinitionId(String scopeDefinitionId)`
  Only select tasks for the given scope definition identifier.
  `T`
  `scopeId(String scopeId)`
  Only select tasks for the given scope identifier.
  `T`
  `scopeType(String scopeType)`
  Only select tasks for the given scope type.
  `T`
  `subScopeId(String subScopeId)`
  Only select tasks for the given sub scope identifier.
  `T`
  `taskAssigned()`
  Only select tasks which are assigned to any user
  `T`
  `taskAssignee(String assignee)`
  Only select tasks which are assigned to the given user.
  `T`
  `taskAssigneeIds(Collection<String> assigneeListIds)`
  Only select tasks with an assignee that is in the given list
  `T`
  `taskAssigneeLike(String assigneeLike)`
  Only select tasks which were last assigned to an assignee like the given value.
  `T`
  `taskAssigneeLikeIgnoreCase(String assigneeLikeIgnoreCase)`
  Only select tasks which were last assigned to an assignee like the given value.
  `T`
  `taskCandidateGroup(String candidateGroup)`
  Only select tasks for which users in the given group are candidates.
  `T`
  `taskCandidateGroupIn(Collection<String> candidateGroups)`
  Only select tasks for which the 'candidateGroup' is one of the given groups.
  `T`
  `taskCandidateUser(String candidateUser)`
  Only select tasks for which the given user is a candidate.
  `T`
  `taskCategory(String category)`
  Only select tasks with the given category.
  `T`
  `taskCategoryIn(Collection<String> taskCategoryInList)`
  Only select tasks belonging to one of the categories in the given list.
  `T`
  `taskCategoryNotIn(Collection<String> taskCategoryNotInList)`
  Only select tasks with a defined category which do not belong to a category present in the given list.
  `T`
  `taskClaimedAfter(Date after)`
  Only select tasks that are claimed after the given date.
  `T`
  `taskClaimedBefore(Date before)`
  Only select tasks that are claimed before the given date.
  `T`
  `taskClaimedBy(String claimedBy)`
  Select all tasks that have a claimed by user reference for the given value.
  `T`
  `taskClaimedOn(Date claimedTime)`
  Only select tasks that are claimed on the given date.
  `T`
  `taskCreatedAfter(Date after)`
  Only select tasks that are created after the given date.
  `T`
  `taskCreatedBefore(Date before)`
  Only select tasks that are created before the given date.
  `T`
  `taskCreatedOn(Date createTime)`
  Only select tasks that are created on the given date.
  `T`
  `taskDefinitionId(String taskDefinitionId)`
  Only select tasks which created from the given task definition referenced by id.
  `T`
  `taskDefinitionKey(String key)`
  Only select tasks with the given taskDefinitionKey.
  `T`
  `taskDefinitionKeyLike(String keyLike)`
  Only select tasks with a taskDefinitionKey that match the given parameter.
  `T`
  `taskDefinitionKeys(Collection<String> keys)`
  Only select tasks with the given taskDefinitionKeys.
  `T`
  `taskDescription(String description)`
  Only select tasks with the given description.
  `T`
  `taskDescriptionLike(String descriptionLike)`
  Only select tasks with a description matching the parameter .
  `T`
  `taskDescriptionLikeIgnoreCase(String descriptionLike)`
  Only select tasks with a description matching the parameter .
  `T`
  `taskDueAfter(Date dueDate)`
  Only select tasks which have a due date after the given date.
  `T`
  `taskDueBefore(Date dueDate)`
  Only select tasks which have a due date before the given date.
  `T`
  `taskDueDate(Date dueDate)`
  Only select tasks with the given due date.
  `T`
  `taskFormKey(String formKey)`
  Only select tasks with the given formKey.
  `T`
  `taskId(String taskId)`
  Only select tasks with the given task id (in practice, there will be maximum one of this kind)
  `T`
  `taskIds(Collection<String> taskIds)`
  Only select tasks with an id that is in the given list
  `T`
  `taskInProgressStartDueAfter(Date dueDate)`
  Only select tasks which have an in progress start due date after the given date.
  `T`
  `taskInProgressStartDueBefore(Date dueDate)`
  Only select tasks which have an in progress start due date before the given date.
  `T`
  `taskInProgressStartDueDate(Date dueDate)`
  Only select tasks with the given in progress start due date.
  `T`
  `taskInProgressStartedBy(String startedBy)`
  Select all tasks that have an in progress started user reference for the given value.
  `T`
  `taskInProgressStartTimeAfter(Date after)`
  Only select tasks that are started in progress after the given date.
  `T`
  `taskInProgressStartTimeBefore(Date before)`
  Only select tasks that are started in progress before the given date.
  `T`
  `taskInProgressStartTimeOn(Date claimedTime)`
  Only select tasks that are started in progress on the given date.
  `T`
  `taskInvolvedGroups(Collection<String> involvedGroup)`
  Only select tasks for which there exist an `IdentityLink` with the given Groups.
  `T`
  `taskInvolvedUser(String involvedUser)`
  Only select tasks for which there exist an `IdentityLink` with the given user, including tasks which have been assigned to the given user (assignee) or owned by the given user (owner).
  `T`
  `taskMaxPriority(Integer maxPriority)`
  Only select tasks with the given priority or lower.
  `T`
  `taskMinPriority(Integer minPriority)`
  Only select tasks with the given priority or higher.
  `T`
  `taskName(String name)`
  Only select tasks with the given name
  `T`
  `taskNameIn(Collection<String> nameList)`
  Only select tasks with a name that is in the given list
  `T`
  `taskNameInIgnoreCase(Collection<String> nameList)`
  Only select tasks with a name that is in the given list This method, unlike the `taskNameIn(Collection)` method will not take in account the upper/lower case: both the input parameters as the column value are lowercased when the query is executed.
  `T`
  `taskNameLike(String nameLike)`
  Only select tasks with a name matching the parameter.
  `T`
  `taskNameLikeIgnoreCase(String nameLike)`
  Only select tasks with a name matching the parameter.
  `T`
  `taskOwner(String owner)`
  Only select tasks for which the given user is the owner.
  `T`
  `taskOwnerLike(String ownerLike)`
  Only select tasks which were last assigned to an owner like the given value.
  `T`
  `taskOwnerLikeIgnoreCase(String ownerLikeIgnoreCase)`
  Only select tasks which were last assigned to an owner like the given value.
  `T`
  `taskParentScopeId(String parentScopeId)`
  Only selects tasks which with the given parent scope id
  `T`
  `taskPriority(Integer priority)`
  Only select tasks with the given priority.
  `T`
  `taskRootScopeId(String parentScopeId)`
  Only selects tasks which with the given root scope id
  `T`
  `taskState(String state)`
  Only select tasks with the given state.
  `T`
  `taskSuspendedAfter(Date after)`
  Only select tasks that are suspended after the given date.
  `T`
  `taskSuspendedBefore(Date before)`
  Only select tasks that are suspended before the given date.
  `T`
  `taskSuspendedBy(String suspendedBy)`
  Select all tasks that have a suspended by user reference for the given value.
  `T`
  `taskSuspendedOn(Date suspendedTime)`
  Only select tasks that are suspended on the given date.
  `T`
  `taskTenantId(String tenantId)`
  Only select tasks that have the given tenant id.
  `T`
  `taskTenantIdLike(String tenantIdLike)`
  Only select tasks with a tenant id like the given one.
  `T`
  `taskUnassigned()`
  Only select tasks which don't have an assignee.
  `T`
  `taskVariableExists(String name)`
  Only select tasks which have a local variable with the given name.
  `T`
  `taskVariableNotExists(String name)`
  Only select tasks which does not have a local variable with the given name.
  `T`
  `taskVariableValueEquals(Object variableValue)`
  Only select tasks which have at least one local task variable with the given value.
  `T`
  `taskVariableValueEquals(String variableName, Object variableValue)`
  Only select tasks which have a local task variable with the given name set to the given value.
  `T`
  `taskVariableValueEqualsIgnoreCase(String name, String value)`
  Only select tasks which have a local string variable with the given value, case insensitive.
  `T`
  `taskVariableValueGreaterThan(String name, Object value)`
  Only select tasks which have a local variable value greater than the passed value when they ended.
  `T`
  `taskVariableValueGreaterThanOrEqual(String name, Object value)`
  Only select tasks which have a local variable value greater than or equal to the passed value when they ended.
  `T`
  `taskVariableValueLessThan(String name, Object value)`
  Only select tasks which have a local variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
  `T`
  `taskVariableValueLessThanOrEqual(String name, Object value)`
  Only select tasks which have a local variable value less than or equal to the passed value when they ended.
  `T`
  `taskVariableValueLike(String name, String value)`
  Only select tasks which have a local variable value like the given value when they ended.
  `T`
  `taskVariableValueLikeIgnoreCase(String name, String value)`
  Only select tasks which have a local variable value like the given value (case insensitive) when they ended.
  `T`
  `taskVariableValueNotEquals(String variableName, Object variableValue)`
  Only select tasks which have a local task variable with the given name, but with a different value than the passed value.
  `T`
  `taskVariableValueNotEqualsIgnoreCase(String name, String value)`
  Only select tasks which have a local string variable with is not the given value, case insensitive.
  `T`
  `taskWithFormKey()`
  Only select tasks with form key.
  `T`
  `taskWithoutCategory()`
  Selects tasks without category.
  `T`
  `taskWithoutTenantId()`
  Only select tasks that do not have a tenant id.
  `T`
  `withLocalizationFallback()`
  Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.
  `T`
  `withoutProcessInstanceId()`
  Only select tasks without a process instance id.
  `T`
  `withoutScopeId()`
  Only select tasks which don't have a scope id set.
  `T`
  `withoutTaskDueDate()`
  Only select tasks with no due date.
  `T`
  `withoutTaskInProgressStartDueDate()`
  Only select tasks with no in progress start due date.

  ### Methods inherited from interface org.flowable.common.engine.api.query.Query

  `asc, count, desc, list, listPage, orderBy, orderBy, singleResult`

- ## Method Details

  - ### taskId

    T taskId(String taskId)
    Only select tasks with the given task id (in practice, there will be maximum one of this kind)

  - ### taskIds

    T taskIds(Collection<String> taskIds)
    Only select tasks with an id that is in the given list
    Throws:
      `FlowableIllegalArgumentException` - When passed id list is empty or `null` or contains `null String`.

  - ### taskName

    T taskName(String name)
    Only select tasks with the given name

  - ### taskNameIn

    T taskNameIn(Collection<String> nameList)
    Only select tasks with a name that is in the given list
    Throws:
      `FlowableIllegalArgumentException` - When passed name list is empty or `null` or contains `null String`.

  - ### taskNameInIgnoreCase

    T taskNameInIgnoreCase(Collection<String> nameList)
    Only select tasks with a name that is in the given list This method, unlike the `taskNameIn(Collection)` method will not take in account the upper/lower case: both the input parameters as the column value are lowercased when the query is executed.
    Throws:
      `FlowableIllegalArgumentException` - When passed name list is empty or `null` or contains `null String`.

  - ### taskNameLike

    T taskNameLike(String nameLike)
    Only select tasks with a name matching the parameter. The syntax is that of SQL: for example usage: nameLike(%test%)

  - ### taskNameLikeIgnoreCase

    T taskNameLikeIgnoreCase(String nameLike)
    Only select tasks with a name matching the parameter. The syntax is that of SQL: for example usage: nameLike(%test%) This method, unlike the `taskNameLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

  - ### taskDescription

    T taskDescription(String description)
    Only select tasks with the given description.

  - ### taskDescriptionLike

    T taskDescriptionLike(String descriptionLike)
    Only select tasks with a description matching the parameter . The syntax is that of SQL: for example usage: descriptionLike(%test%)

  - ### taskDescriptionLikeIgnoreCase

    T taskDescriptionLikeIgnoreCase(String descriptionLike)
    Only select tasks with a description matching the parameter . The syntax is that of SQL: for example usage: descriptionLike(%test%) This method, unlike the `taskDescriptionLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

  - ### taskPriority

    T taskPriority(Integer priority)
    Only select tasks with the given priority.

  - ### taskMinPriority

    T taskMinPriority(Integer minPriority)
    Only select tasks with the given priority or higher.

  - ### taskMaxPriority

    T taskMaxPriority(Integer maxPriority)
    Only select tasks with the given priority or lower.

  - ### taskAssignee

    T taskAssignee(String assignee)
    Only select tasks which are assigned to the given user.

  - ### taskAssigneeLike

    T taskAssigneeLike(String assigneeLike)
    Only select tasks which were last assigned to an assignee like the given value. The syntax that should be used is the same as in SQL, eg. %test%.

  - ### taskAssigneeLikeIgnoreCase

    T taskAssigneeLikeIgnoreCase(String assigneeLikeIgnoreCase)
    Only select tasks which were last assigned to an assignee like the given value. The syntax that should be used is the same as in SQL, eg. %test%. This method, unlike the `taskAssigneeLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

  - ### taskUnassigned

    T taskUnassigned()
    Only select tasks which don't have an assignee.

  - ### taskAssigned

    T taskAssigned()
    Only select tasks which are assigned to any user

  - ### taskAssigneeIds

    T taskAssigneeIds(Collection<String> assigneeListIds)
    Only select tasks with an assignee that is in the given list
    Throws:
      `FlowableIllegalArgumentException` - When passed name list is empty or `null` or contains `null String`.

  - ### taskOwner

    T taskOwner(String owner)
    Only select tasks for which the given user is the owner.

  - ### taskOwnerLike

    T taskOwnerLike(String ownerLike)
    Only select tasks which were last assigned to an owner like the given value. The syntax that should be used is the same as in SQL, eg. %test%.

  - ### taskOwnerLikeIgnoreCase

    T taskOwnerLikeIgnoreCase(String ownerLikeIgnoreCase)
    Only select tasks which were last assigned to an owner like the given value. The syntax that should be used is the same as in SQL, eg. %test%. This method, unlike the `taskOwnerLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

  - ### taskCandidateUser

    T taskCandidateUser(String candidateUser)
    Only select tasks for which the given user is a candidate.

  - ### taskInvolvedUser

    T taskInvolvedUser(String involvedUser)
    Only select tasks for which there exist an `IdentityLink` with the given user, including tasks which have been assigned to the given user (assignee) or owned by the given user (owner).

  - ### taskInvolvedGroups

    T taskInvolvedGroups(Collection<String> involvedGroup)
    Only select tasks for which there exist an `IdentityLink` with the given Groups.

  - ### ignoreAssigneeValue

    T ignoreAssigneeValue()
    Allows to select a task using `taskCandidateGroup(String)` `taskCandidateGroupIn(Collection)` or `taskCandidateUser(String)` but ignore the assignee value instead of querying for an empty assignee.

  - ### taskCandidateGroup

    T taskCandidateGroup(String candidateGroup)
    Only select tasks for which users in the given group are candidates.

  - ### taskCandidateGroupIn

    T taskCandidateGroupIn(Collection<String> candidateGroups)
    Only select tasks for which the 'candidateGroup' is one of the given groups.
    Throws:
      `FlowableIllegalArgumentException` - When query is executed and `taskCandidateGroup(String)` or `taskCandidateUser(String)` has been executed on the query instance. When passed group list is empty or `null`.

  - ### taskTenantId

    T taskTenantId(String tenantId)
    Only select tasks that have the given tenant id.

  - ### taskTenantIdLike

    T taskTenantIdLike(String tenantIdLike)
    Only select tasks with a tenant id like the given one.

  - ### taskWithoutTenantId

    T taskWithoutTenantId()
    Only select tasks that do not have a tenant id.

  - ### processInstanceId

    T processInstanceId(String processInstanceId)
    Only select tasks for the given process instance id.

  - ### processInstanceIdIn

    T processInstanceIdIn(Collection<String> processInstanceIds)
    Only select tasks for the given process ids.

  - ### withoutProcessInstanceId

    T withoutProcessInstanceId()
    Only select tasks without a process instance id.

  - ### processInstanceBusinessKey

    T processInstanceBusinessKey(String processInstanceBusinessKey)
    Only select tasks for the given business key

  - ### processInstanceBusinessKeyLike

    T processInstanceBusinessKeyLike(String processInstanceBusinessKeyLike)
    Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%test%").

  - ### processInstanceBusinessKeyLikeIgnoreCase

    T processInstanceBusinessKeyLikeIgnoreCase(String processInstanceBusinessKeyLikeIgnoreCase)
    Only select tasks with a business key like the given value The syntax is that of SQL: for example usage: processInstanceBusinessKeyLike("%test%"). This method, unlike the `processInstanceBusinessKeyLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

  - ### executionId

    T executionId(String executionId)
    Only select tasks for the given execution.

  - ### caseInstanceId

    T caseInstanceId(String caseInstanceId)
    Only select tasks for the given case instance.

  - ### caseDefinitionId

    T caseDefinitionId(String caseDefinitionId)
    Only select tasks for the given case definition.

  - ### caseDefinitionKey

    T caseDefinitionKey(String caseDefinitionKey)
    Only select tasks which are part of a case instance which has the given case definition key.

  - ### caseDefinitionKeyLike

    T caseDefinitionKeyLike(String caseDefinitionKeyLike)
    Only select tasks which are part of a case instance which has a case definition key like the given value. The syntax that should be used is the same as in SQL, eg. %test%.

  - ### caseDefinitionKeyLikeIgnoreCase

    T caseDefinitionKeyLikeIgnoreCase(String caseDefinitionKeyLikeIgnoreCase)
    Only select tasks which are part of a case instance which has a case definition key like the given value. The syntax that should be used is the same as in SQL, eg. %test%. This method, unlike the `caseDefinitionKeyLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

  - ### caseDefinitionKeyIn

    T caseDefinitionKeyIn(Collection<String> caseDefinitionKeys)
    Only select tasks that have a case definition for which the key is present in the given list

  - ### planItemInstanceId

    T planItemInstanceId(String planItemInstanceId)
    Only select tasks for the given plan item instance.

  - ### scopeId

    T scopeId(String scopeId)
    Only select tasks for the given scope identifier.

  - ### subScopeId

    T subScopeId(String subScopeId)
    Only select tasks for the given sub scope identifier.

  - ### scopeType

    T scopeType(String scopeType)
    Only select tasks for the given scope type.

  - ### scopeDefinitionId

    T scopeDefinitionId(String scopeDefinitionId)
    Only select tasks for the given scope definition identifier.

  - ### propagatedStageInstanceId

    T propagatedStageInstanceId(String propagatedStageInstanceId)
    Only select tasks for the given stage, defined through its stage instance id.

  - ### processInstanceIdWithChildren

    T processInstanceIdWithChildren(String processInstanceId)
    Select all tasks for the given process instance id and its children.

  - ### caseInstanceIdWithChildren

    T caseInstanceIdWithChildren(String caseInstanceId)
    Select all tasks for the given case instance id and its children.

  - ### taskCreatedOn

    T taskCreatedOn(Date createTime)
    Only select tasks that are created on the given date.

  - ### taskCreatedBefore

    T taskCreatedBefore(Date before)
    Only select tasks that are created before the given date.

  - ### taskCreatedAfter

    T taskCreatedAfter(Date after)
    Only select tasks that are created after the given date.

  - ### taskInProgressStartTimeOn

    T taskInProgressStartTimeOn(Date claimedTime)
    Only select tasks that are started in progress on the given date.

  - ### taskInProgressStartTimeBefore

    T taskInProgressStartTimeBefore(Date before)
    Only select tasks that are started in progress before the given date.

  - ### taskInProgressStartTimeAfter

    T taskInProgressStartTimeAfter(Date after)
    Only select tasks that are started in progress after the given date.

  - ### taskInProgressStartedBy

    T taskInProgressStartedBy(String startedBy)
    Select all tasks that have an in progress started user reference for the given value.

  - ### taskClaimedOn

    T taskClaimedOn(Date claimedTime)
    Only select tasks that are claimed on the given date.

  - ### taskClaimedBefore

    T taskClaimedBefore(Date before)
    Only select tasks that are claimed before the given date.

  - ### taskClaimedAfter

    T taskClaimedAfter(Date after)
    Only select tasks that are claimed after the given date.

  - ### taskClaimedBy

    T taskClaimedBy(String claimedBy)
    Select all tasks that have a claimed by user reference for the given value.

  - ### taskSuspendedOn

    T taskSuspendedOn(Date suspendedTime)
    Only select tasks that are suspended on the given date.

  - ### taskSuspendedBefore

    T taskSuspendedBefore(Date before)
    Only select tasks that are suspended before the given date.

  - ### taskSuspendedAfter

    T taskSuspendedAfter(Date after)
    Only select tasks that are suspended after the given date.

  - ### taskSuspendedBy

    T taskSuspendedBy(String suspendedBy)
    Select all tasks that have a suspended by user reference for the given value.

  - ### taskCategory

    T taskCategory(String category)
    Only select tasks with the given category.

  - ### taskCategoryIn

    T taskCategoryIn(Collection<String> taskCategoryInList)
    Only select tasks belonging to one of the categories in the given list.
    Parameters:
      `taskCategoryInList` -
    Throws:
      `FlowableIllegalArgumentException` - When passed category list is empty or `null` or contains `null` String.

  - ### taskCategoryNotIn

    T taskCategoryNotIn(Collection<String> taskCategoryNotInList)
    Only select tasks with a defined category which do not belong to a category present in the given list.

    NOTE: This method does not return tasks without category e.g. tasks having a `null` category. To include `null` categories, use `query.or().taskCategoryNotIn(...).taskWithoutCategory().endOr()`

    Parameters:
      `taskCategoryNotInList` -
    Throws:
      `FlowableIllegalArgumentException` - When passed category list is empty or `null` or contains `null String`.
    See Also:
      - `taskWithoutCategory()`

  - ### taskWithoutCategory

    T taskWithoutCategory()
    Selects tasks without category.

    Can also be used in conjunction with other filter criteria to include tasks without category e.g. in `or` queries.

    See Also:
      - `taskCategoryNotIn(Collection)`

  - ### taskWithFormKey

    T taskWithFormKey()
    Only select tasks with form key.

  - ### taskFormKey

    T taskFormKey(String formKey)
    Only select tasks with the given formKey.

  - ### taskDefinitionKey

    T taskDefinitionKey(String key)
    Only select tasks with the given taskDefinitionKey. The task definition key is the id of the userTask: <userTask id="xxx" .../>

  - ### taskDefinitionKeyLike

    T taskDefinitionKeyLike(String keyLike)
    Only select tasks with a taskDefinitionKey that match the given parameter. The syntax is that of SQL: for example usage: taskDefinitionKeyLike("%test%"). The task definition key is the id of the userTask: <userTask id="xxx" .../>

  - ### taskDefinitionKeys

    T taskDefinitionKeys(Collection<String> keys)
    Only select tasks with the given taskDefinitionKeys. The task definition key is the id of the userTask: <userTask id="xxx" .../>

  - ### taskState

    T taskState(String state)
    Only select tasks with the given state.

  - ### taskInProgressStartDueDate

    T taskInProgressStartDueDate(Date dueDate)
    Only select tasks with the given in progress start due date.

  - ### taskInProgressStartDueBefore

    T taskInProgressStartDueBefore(Date dueDate)
    Only select tasks which have an in progress start due date before the given date.

  - ### taskInProgressStartDueAfter

    T taskInProgressStartDueAfter(Date dueDate)
    Only select tasks which have an in progress start due date after the given date.

  - ### withoutTaskInProgressStartDueDate

    T withoutTaskInProgressStartDueDate()
    Only select tasks with no in progress start due date.

  - ### taskDueDate

    T taskDueDate(Date dueDate)
    Only select tasks with the given due date.

  - ### taskDueBefore

    T taskDueBefore(Date dueDate)
    Only select tasks which have a due date before the given date.

  - ### taskDueAfter

    T taskDueAfter(Date dueDate)
    Only select tasks which have a due date after the given date.

  - ### withoutTaskDueDate

    T withoutTaskDueDate()
    Only select tasks with no due date.

  - ### processDefinitionKey

    T processDefinitionKey(String processDefinitionKey)
    Only select tasks which are part of a process instance which has the given process definition key.

  - ### processDefinitionKeyLike

    T processDefinitionKeyLike(String processDefinitionKeyLike)
    Only select tasks which are part of a process instance which has a process definition key like the given value. The syntax that should be used is the same as in SQL, eg. %test%.

  - ### processDefinitionKeyLikeIgnoreCase

    T processDefinitionKeyLikeIgnoreCase(String processDefinitionKeyLikeIgnoreCase)
    Only select tasks which are part of a process instance which has a process definition key like the given value. The syntax that should be used is the same as in SQL, eg. %test%. This method, unlike the `processDefinitionKeyLike(String)` method will not take in account the upper/lower case: both the input parameter as the column value are lowercased when the query is executed.

  - ### processDefinitionKeyIn

    T processDefinitionKeyIn(Collection<String> processDefinitionKeys)
    Only select tasks that have a process definition for which the key is present in the given list

  - ### taskDefinitionId

    T taskDefinitionId(String taskDefinitionId)
    Only select tasks which created from the given task definition referenced by id.

  - ### processDefinitionId

    T processDefinitionId(String processDefinitionId)
    Only select tasks which are part of a process instance which has the given process definition id.

  - ### processDefinitionName

    T processDefinitionName(String processDefinitionName)
    Only select tasks which are part of a process instance which has the given process definition name.

  - ### processDefinitionNameLike

    T processDefinitionNameLike(String processDefinitionNameLike)
    Only select tasks which are part of a process instance which has a process definition name like the given value. The syntax that should be used is the same as in SQL, eg. %test%.

  - ### processCategoryIn

    T processCategoryIn(Collection<String> processCategoryInList)
    Only select tasks which are part of a process instance whose definition belongs to the category which is present in the given list.
    Parameters:
      `processCategoryInList` -
    Throws:
      `FlowableIllegalArgumentException` - When passed category list is empty or `null` or contains `null String`.

  - ### processCategoryNotIn

    T processCategoryNotIn(Collection<String> processCategoryNotInList)
    Only select tasks which are part of a process instance whose definition does not belong to the category which is present in the given list.
    Parameters:
      `processCategoryNotInList` -
    Throws:
      `FlowableIllegalArgumentException` - When passed category list is empty or `null` or contains `null String`.

  - ### deploymentId

    T deploymentId(String deploymentId)
    Only select tasks which are part of a process instance which has the given deployment id.

  - ### deploymentIdIn

    T deploymentIdIn(Collection<String> deploymentIds)
    Only select tasks which are part of a process instance which has the given deployment id.

  - ### cmmnDeploymentId

    T cmmnDeploymentId(String cmmnDeploymentId)
    Only select tasks which are related to a case instance for to the given deployment id.

  - ### cmmnDeploymentIdIn

    T cmmnDeploymentIdIn(Collection<String> cmmnDeploymentIds)
    Only select tasks which are related to a case instances for the given deployment id.

  - ### withoutScopeId

    T withoutScopeId()
    Only select tasks which don't have a scope id set.

  - ### taskVariableValueEquals

    T taskVariableValueEquals(String variableName, Object variableValue)
    Only select tasks which have a local task variable with the given name set to the given value.

  - ### taskVariableValueEquals

    T taskVariableValueEquals(Object variableValue)
    Only select tasks which have at least one local task variable with the given value.

  - ### taskVariableValueEqualsIgnoreCase

    T taskVariableValueEqualsIgnoreCase(String name, String value)
    Only select tasks which have a local string variable with the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

  - ### taskVariableValueNotEquals

    T taskVariableValueNotEquals(String variableName, Object variableValue)
    Only select tasks which have a local task variable with the given name, but with a different value than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

  - ### taskVariableValueNotEqualsIgnoreCase

    T taskVariableValueNotEqualsIgnoreCase(String name, String value)
    Only select tasks which have a local string variable with is not the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

  - ### taskVariableValueGreaterThan

    T taskVariableValueGreaterThan(String name, Object value)
    Only select tasks which have a local variable value greater than the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### taskVariableValueGreaterThanOrEqual

    T taskVariableValueGreaterThanOrEqual(String name, Object value)
    Only select tasks which have a local variable value greater than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### taskVariableValueLessThan

    T taskVariableValueLessThan(String name, Object value)
    Only select tasks which have a local variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### taskVariableValueLessThanOrEqual

    T taskVariableValueLessThanOrEqual(String name, Object value)
    Only select tasks which have a local variable value less than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### taskVariableValueLike

    T taskVariableValueLike(String name, String value)
    Only select tasks which have a local variable value like the given value when they ended. This can be used on string variables only.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### taskVariableValueLikeIgnoreCase

    T taskVariableValueLikeIgnoreCase(String name, String value)
    Only select tasks which have a local variable value like the given value (case insensitive) when they ended. This can be used on string variables only.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### taskVariableExists

    T taskVariableExists(String name)
    Only select tasks which have a local variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### taskVariableNotExists

    T taskVariableNotExists(String name)
    Only select tasks which does not have a local variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### processVariableValueEquals

    T processVariableValueEquals(String variableName, Object variableValue)
    Only select tasks which are part of a process that has a variable with the given name set to the given value.

  - ### processVariableValueEquals

    T processVariableValueEquals(Object variableValue)
    Only select tasks which are part of a process that has at least one variable with the given value.

  - ### processVariableValueEqualsIgnoreCase

    T processVariableValueEqualsIgnoreCase(String name, String value)
    Only select tasks which are part of a process that has a local string variable which is not the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

  - ### processVariableValueNotEquals

    T processVariableValueNotEquals(String variableName, Object variableValue)
    Only select tasks which have a variable with the given name, but with a different value than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

  - ### processVariableValueNotEqualsIgnoreCase

    T processVariableValueNotEqualsIgnoreCase(String name, String value)
    Only select tasks which are part of a process that has a string variable with the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

  - ### processVariableValueGreaterThan

    T processVariableValueGreaterThan(String name, Object value)
    Only select tasks which have a global variable value greater than the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### processVariableValueGreaterThanOrEqual

    T processVariableValueGreaterThanOrEqual(String name, Object value)
    Only select tasks which have a global variable value greater than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### processVariableValueLessThan

    T processVariableValueLessThan(String name, Object value)
    Only select tasks which have a global variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### processVariableValueLessThanOrEqual

    T processVariableValueLessThanOrEqual(String name, Object value)
    Only select tasks which have a global variable value less than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### processVariableValueLike

    T processVariableValueLike(String name, String value)
    Only select tasks which have a global variable value like the given value when they ended. This can be used on string variables only.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### processVariableValueLikeIgnoreCase

    T processVariableValueLikeIgnoreCase(String name, String value)
    Only select tasks which have a global variable value like the given value (case insensitive) when they ended. This can be used on string variables only.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### processVariableExists

    T processVariableExists(String name)
    Only select tasks which have a global variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### processVariableNotExists

    T processVariableNotExists(String name)
    Only select tasks which does not have a global variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### caseVariableValueEquals

    T caseVariableValueEquals(String variableName, Object variableValue)
    Only select tasks which are part of a case that has a variable with the given name set to the given value.

  - ### caseVariableValueEquals

    T caseVariableValueEquals(Object variableValue)
    Only select tasks which are part of a case that has at least one variable with the given value.

  - ### caseVariableValueEqualsIgnoreCase

    T caseVariableValueEqualsIgnoreCase(String name, String value)
    Only select tasks which are part of a case that has a local string variable which is not the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

  - ### caseVariableValueNotEquals

    T caseVariableValueNotEquals(String variableName, Object variableValue)
    Only select tasks which have a variable with the given name, but with a different value than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

  - ### caseVariableValueNotEqualsIgnoreCase

    T caseVariableValueNotEqualsIgnoreCase(String name, String value)
    Only select tasks which are part of a case that has a string variable with the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

  - ### caseVariableValueGreaterThan

    T caseVariableValueGreaterThan(String name, Object value)
    Only select tasks which have a global variable value greater than the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### caseVariableValueGreaterThanOrEqual

    T caseVariableValueGreaterThanOrEqual(String name, Object value)
    Only select tasks which have a global variable value greater than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### caseVariableValueLessThan

    T caseVariableValueLessThan(String name, Object value)
    Only select tasks which have a global variable value less than the passed value when the ended.Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### caseVariableValueLessThanOrEqual

    T caseVariableValueLessThanOrEqual(String name, Object value)
    Only select tasks which have a global variable value less than or equal to the passed value when they ended. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null.

  - ### caseVariableValueLike

    T caseVariableValueLike(String name, String value)
    Only select tasks which have a global variable value like the given value when they ended. This can be used on string variables only.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### caseVariableValueLikeIgnoreCase

    T caseVariableValueLikeIgnoreCase(String name, String value)
    Only select tasks which have a global variable value like the given value (case insensitive) when they ended. This can be used on string variables only.
    Parameters:
      `name` - cannot be null.
      `value` - cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### caseVariableExists

    T caseVariableExists(String name)
    Only select tasks which have a global variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### caseVariableNotExists

    T caseVariableNotExists(String name)
    Only select tasks which does not have a global variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### taskRootScopeId

    T taskRootScopeId(String parentScopeId)
    Only selects tasks which with the given root scope id

  - ### taskParentScopeId

    T taskParentScopeId(String parentScopeId)
    Only selects tasks which with the given parent scope id

  - ### includeTaskLocalVariables

    T includeTaskLocalVariables()
    Include local task variables in the task query result

  - ### includeProcessVariables

    T includeProcessVariables()
    Include global process variables in the task query result

  - ### includeCaseVariables

    T includeCaseVariables()
    Include global case variables in the task query result

  - ### includeIdentityLinks

    T includeIdentityLinks()
    Include identity links in the task query result

  - ### locale

    T locale(String locale)
    Localize task name and description to specified locale.

  - ### withLocalizationFallback

    T withLocalizationFallback()
    Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.

  - ### or

    T or()
    All query clauses called will be added to a single or-statement. This or-statement will be included with the other already existing clauses in the query, joined by an 'and'.

    Calling endOr() will add all clauses to the regular query again. Calling or() after or() has been called or calling endOr() after endOr() has been called will result in an exception. It is possible to call or() endOr() several times if each or() has a matching endOr(), e.g.:

    `query.<ConditionA>` `.or().<conditionB>.<conditionC>.endOr()` `.<conditionD>.<conditionE>` `.or().<conditionF>.<conditionG>.endOr()`

    will result in: conditionA & (conditionB | conditionC) & conditionD & conditionE & (conditionF | conditionG)

  - ### endOr

    T endOr()

  - ### orderByTaskId

    T orderByTaskId()
    Order by task id (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskName

    T orderByTaskName()
    Order by task name (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskDescription

    T orderByTaskDescription()
    Order by description (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskPriority

    T orderByTaskPriority()
    Order by priority (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskAssignee

    T orderByTaskAssignee()
    Order by assignee (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskCreateTime

    T orderByTaskCreateTime()
    Order by the time on which the tasks were created (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByProcessInstanceId

    T orderByProcessInstanceId()
    Order by process instance id (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByExecutionId

    T orderByExecutionId()
    Order by execution id (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByProcessDefinitionId

    T orderByProcessDefinitionId()
    Order by process definition id (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskDueDate

    T orderByTaskDueDate()
    Order by task due date (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskOwner

    T orderByTaskOwner()
    Order by task owner (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTaskDefinitionKey

    T orderByTaskDefinitionKey()
    Order by task definition key (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByTenantId

    T orderByTenantId()
    Order by tenant id (needs to be followed by `Query.asc()` or `Query.desc()`).

  - ### orderByDueDateNullsFirst

    T orderByDueDateNullsFirst()
    Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`). If any of the tasks have null for the due date, these will be first in the result.

  - ### orderByDueDateNullsLast

    T orderByDueDateNullsLast()
    Order by due date (needs to be followed by `Query.asc()` or `Query.desc()`). If any of the tasks have null for the due date, these will be last in the result.

  - ### orderByCategory

    T orderByCategory()
    Order by category (needs to be followed by `Query.asc()` or `Query.desc()`).